#include <stdlib.h>
#include <ctype.h>
#include <iostream>
#include "global.h"

void sortcells() {
  int      cols, rows;
  int      i, j, k;
  float    wert;
  char     *pcells;
  short    numflag, newgroup;
  String   **cells, *tmp;

  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNrows, &rows, NULL);
  XtVaGetValues(StatData, XmNcells, &cells, NULL);

  /* sort data matrix by sort variables */
  for (k=sort.nsort-1; k>=0; k--) {   // loop through sort variables;
    /* find out whether variable is numeric or alpha */
    numflag=1;
    for (i=0; i<rows; i++) {
      wert=strtod(cells[i][sort.sort[k]], &pcells);
      if (wert==0 && !strcmp(pcells,cells[i][sort.sort[k]])) {
	numflag=0;
      }
    }
    for (i=0; i<rows-2; i++) {
      for (j=0; j<rows-1-i; j++) {
	if (numflag) {
	  if (atof(cells[j][sort.sort[k]]) > atof(cells[j+1][sort.sort[k]])) {
	    /* change a whole row at once */
	    tmp=cells[j];
	    cells[j]=cells[j+1];
	    cells[j+1]=tmp;
	  }
	}
	else {
	  if (strcmp(cells[j][sort.sort[k]], cells[j+1][sort.sort[k]]) > 0) {
	    /* change a whole row at once */
	    tmp=cells[j];
	    cells[j]=cells[j+1];
	    cells[j+1]=tmp;
	  }
	}
      }
    }
  }
  /* define various groups based on the sort variables */
  sort.ngroup=1; 
  sort.group=(int *) realloc(sort.group, sort.ngroup * sizeof(int));
  sort.group[sort.ngroup-1]=1;
  for (i=1; i<rows; i++) {
    newgroup=0; 
    for (j=0; j<sort.nsort; j++) {
      if (strcmp(cells[i-1][sort.sort[j]], cells[i][sort.sort[j]]) != 0 ) {
	newgroup=1;
      }
    }
    if (newgroup==0) sort.group[sort.ngroup-1]++;
    /* new group found */
    else {
      sort.ngroup++;
      sort.group=(int *) realloc(sort.group, sort.ngroup * sizeof(int));
      sort.group[sort.ngroup-1]=1;
    }
  }

  XbaeMatrixCancelEdit(StatData,False);

}
